package drakfirsttime::gui;

use strict;
use lib qw(/usr/lib/libDrakX);
use standalone;

use common;
use any;
BEGIN { unshift @::textdomains, 'drakfw' }
#use interactive;
use ugtk2 qw(:all :create);

use LWP::UserAgent;
use Net::HTTP;
use HTTP::Message;
use HTTP::Request;
use Expect;

use lib qw(/usr/lib/libDrakX/drakfirsttime);
use data;
use comdialog;
use IO::Stty;

#$Expect::Log_Stdout=1;
#$Expect::Debug=3;
#$Expect::Exp_Internal=1;

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $this = bless({
		      version => "0.91",
		      drakfw => N("First Time Wizard") ,
		      mdkclub => N("Mandrakeclub Registration"),
		      kdeconfdir => "$ENV{HOME}/.kde/share/config",
		     }, $class);
    my $rc = "/usr/share/themes/Galaxy/gtk-2.0/gtkrc";
    Gtk2::Rc->parse($rc);
    add_icon_path("/usr/share/drakfirsttime/pixmaps/");
    $this->initialize(@_);
    return;
}
sub initialize {
    my $this = shift;
    my $prog_name = shift;
    $this->{mw} = ugtk2->new($this->{$prog_name} . " " . $this->{version}, center => 1);
    gtkset_size_request($this->{mw}{window}, 580, 470);
    $this->{mw}{rwindow}->set_position('center');
    $this->{nb} = Gtk2::Notebook->new;
    $this->{Button_SkipWiz} = Gtk2::Button->new(N(" Skip Wizard ")); $this->{Button_Prev} = Gtk2::Button->new(translate("Previous")); $this->{Button_Next} = Gtk2::Button->new(translate("Next")); 
    $this->{Button_Priv} = Gtk2::Button->new(N("Privacy"));
    $this->{is_network} = network_enabled();
    $this->{is_download} = mdk_downloaded();
    my $stage = {
		 drakfw => {
			    0 => sub { $this->{is_download} and $this->survey; $this->start },
			    1 => sub { $this->set_themes; !$this->{is_network} and $this->get2final },
			    2 => sub { if (!$this->{is_network}) { $this->startwm } else { $this->{nb}->next_page } },
			    3 => sub { $this->{is_network} and $this->mdkclub_checkuser },
			    4 => sub { $this->startwm }
			   },
		 mdkclub => {
			     0 => sub { $this->start },
			     2 => sub { $this->mdkclub_checkuser },
			     3 => sub { Gtk2->main_quit }
			    },
		};
    $this->{Button_SkipWiz}->signal_connect(clicked => sub { if ($prog_name eq 'drakfw') { $this->startwm } else { Gtk2->main_quit } });
    $this->{Button_Prev}->signal_connect(clicked => sub { $this->on_prev_clicked($stage->{$prog_name}) });
    $this->{Button_Next}->signal_connect(clicked => sub { $this->on_next_clicked($stage->{$prog_name}) });
    $this->{Button_Priv}->signal_connect(clicked => sub { $this->privacy_dialog });
    my $hbox_final = gtkpack_(Gtk2::HBox->new(0, 5),
			      0, gtkpack__(create_hbox('start'),
					   $this->{Button_SkipWiz},
					   $this->{Button_Priv},
					   ),
			      1, Gtk2::Label->new(""),
			      0, gtkpack__(create_hbox('start'),
					   $this->{Button_Prev},
					   $this->{Button_Next},
					   ),
			      );

    gtkadd($this->{mw}{window},
	   gtkpack_(Gtk2::VBox->new(0, 2),
		    1, gtkset_border_width(gtkadd($this->build_ui($prog_name)), 5),
		    0, Gtk2::HSeparator->new,
		    0, gtkpack($hbox_final),
		   ),
	  );
    $this->{Button_Prev}->set_sensitive(0);
    $this->{Button_Next}->grab_focus;
    $this->{mw}{rwindow}->show_all;
    Gtk2->main;
    ugtk2->exit(0);
}
sub start { my $this = shift; $this->setFirstPage(0); $this->{nb}->next_page }
sub build_ui {
    my $this = shift;
    my $name = shift;
    my $prog = {
		drakfw => sub { $this->drakfirsttime_wizsteps },
		mdkclub => sub { $this->mdkclub_wizsteps },
	       };
     $prog->{$name}->();
}

sub set_clean {
    my $this = shift;
    $this->{nb}->set_show_tabs(0); $this->{nb}->set_show_border(0);
    my $l = Gtk2::Label->new($_[1]);
#    $l->set_line_wrap('TRUE');
    gtkappend_page($this->{nb},
                   gtkpack_(Gtk2::VBox->new(0, 3),
                            0, set_darea($_[0], 'welcome'),
                            1, $l,
                           )
                  );
}


sub drakfirsttime_wizsteps {
    my $this = shift;
    if (mdk_downloaded()) {
	$this->question;
    }
    else { $this->set_clean(N("Welcome to Mandrakefirsttime!"), N("Mandrakefirsttime is an assistant which will help you:\n\n   - to configure the basic setup of your desktop in very few steps\n   - to register your product in order to open easily an Mandrakeclub\n     account and to benefit rapidly from all its products and services!\n\n\n"));
       }
    my $pxm = Gtk2::Image->new;
    $this->{nbthemes} = Gtk2::Notebook->new;
    $this->{nbthemes}->set_show_tabs(0); 
    $this->{nbthemes}->set_show_border(0);
    gtkappend_page($this->{nbthemes}, Gtk2::Label->new(" " . N("Please Select a Desktop Entry") . " "));
    my %k = ( 
		 theme_kde_galaxy_2 => ("Galaxy 2"),
         theme_kde_galaxy_classic => ("Galaxy Classic"),
         theme_kde_galaxy_squared => ("Galaxy Squared"),
         theme_kde_plastik => ("Plastik")
	    );
    my @k_order = qw(theme_kde_galaxy_2 theme_kde_galaxy_classic theme_kde_galaxy_squared theme_kde_plastik);
    my @k_radio = gtkradio($k{theme_kde_galaxy_2}, map { $k{$_} } @k_order);
    mapn {
	my $kptmp = gtkcreate_pixbuf($_[0]); 
	my $need_ktext = $_[1]->get_label;
	$_[1]->signal_connect(clicked => sub { 
				  $pxm->set_from_pixbuf($kptmp); 
				  $this->{kradio} = $need_ktext 
			      });
    } \@k_order, \@k_radio;
    
    gtkappend_page($this->{nbthemes}, gtkpack(Gtk2::VBox->new(0,0), @k_radio));
    
    my %g = (
         theme_gnome_galaxy_2 => ("Galaxy 2"),
         theme_gnome_galaxy_classic => ("Galaxy Classic"),
         theme_gnome_galaxy_squared => ("Galaxy Squared"),
         theme_gnome_smokey_blue => ("Smokey Blue")
	    );
    my @g_order = qw(theme_gnome_galaxy_2 theme_gnome_galaxy_classic theme_gnome_galaxy_squared theme_gnome_smokey_blue);
    my @g_radio = gtkradio($g{theme_gnome_galaxy_2}, map { $g{$_} } @g_order); $this->{gradio} = \@g_radio;
    mapn {
	my $gptmp = gtkcreate_pixbuf($_[0]); 
	my $need_gtext = $_[1]->get_label;
	$_[1]->signal_connect(clicked => sub { 
				  $pxm->set_from_pixbuf($gptmp); 
				  $this->{gradio} = $need_gtext
			      });
    } \@g_order, \@g_radio;
    gtkappend_page($this->{nbthemes}, gtkpack(Gtk2::VBox->new(0,0),@g_radio));
    gtkappend_page($this->{nbthemes}, Gtk2::Label->new(N("No themes available")));
    gtkappend_page($this->{nb},
		   gtkpack_(Gtk2::VBox->new,
			    0, set_darea(N("Desktop Appearance"), 'appearance'),
			    0, Gtk2::Label->new(map { s/\n//g; $_ } N("Now you can choose your Desktop and the theme you want to be set\n")),
			    0, gtkpack_(Gtk2::HBox->new,
					0, gtkpack_(Gtk2::VBox->new(0, 5),
						    0, $this->{wmdesktop} = get_desktop_combo(),
						    0, gtkadd(gtkset_shadow_type(Gtk2::Frame->new(N("Themes")), 'etched_in'),
							      gtkpack(my $vbox_th = Gtk2::VBox->new(0, 0), $this->{nbthemes}
								     ),
							     ),
						   ),
					0, $pxm,
				       ),
			   ),
		  );
    $this->{wmdesktop}->entry->signal_connect(changed => sub { set_background_themes($this->{wmdesktop}->entry->get_text, $this->{nbthemes}, $pxm) });
    network_enabled() and $this->subscribe_mdkclub;
    $this->set_clean(N("Ready to go ?"), N("Congratulations for choosing Mandrakelinux, the easiest and\nmost-friendly Linux distribution!\n\nWe hope it will be an enjoyable experience!\n\nIf you have any questions:\n\n   - about our products: contact us at firsttime\@mandrakesoft.com\n   - about technical support: contact us at support\@mandrakesoft.com\n"));
    $this->{nb};
}
sub mdkclub_wizsteps {
    my $this = shift;
    $this->set_clean(N("Mandrakeclub Account"), N("\nThis assistant will help you to subscribe to Mandrakeclub Services,\n"));
    network_enabled() and $this->subscribe_mdkclub;
    $this->set_clean(N("Thank You"), N("You will have more information about the club community at\nhttp://www.mandrakeclub.com.\n"));
    $this->{nb};
}
sub mdk_downloaded {
    my %dwn = getVarsFromSh('/etc/sysconfig/system');
    my $isdown = $dwn{META_CLASS} eq 'download' ? 1 : 0;
    $isdown;
}
sub display_entry {
    my $this = shift;
    my @t;
    foreach my $l (qw(ent1 ent2 ent3 ent4 ent5)) {
	$this->{$l} = Gtk2::Entry->new_with_max_length(7);
	$this->{$l}->set_size_request(50,25);
	push(@t, $this->{$l});
	push(@t, Gtk2::Label->new("-"));
    };
    pop(@t);
    @t
}
sub get_desktop_combo {
    my $wm_optionmenu = Gtk2::OptionMenu->new;
    my @wm = get_wm_array(); unshift(@wm, N("Choose Desktop"));
    $wm_optionmenu->set_popdown_strings(@wm); 
    $wm_optionmenu;
}
sub set_background_themes {
    my ($wi, $nb, $pxm) = @_;
    my $bg_path = '/usr/share/drakfirsttime/pixmaps/';
    my $bg = { KDE => [ 'kde_desktop.png', 1, 'theme_kde_galaxy_2' ],
           GNOME => [ 'gnome_desktop.png', 2, 'theme_gnome_galaxy_2' ],
           IceWM => [ 'icewm_desktop.png', 3 ],
           Enlightenment => [ 'enlightenment_desktop.png', 3 ],
           WindowMaker => [ 'windowmaker_desktop.png', 3 ],
           Fvwm1 => [ 'fvwm1_desktop.png', 3 ],
           Fvwm2 => [ 'fvwm2_desktop.png', 3 ],
           BlackBox => [ 'blackbox_desktop.png', 3 ],
           fluxbox => [ 'fluxbox_desktop.png', 3 ],
           Olvwm => [ 'olvwm_desktop.png', 3 ],
           PWM => [ 'pwm_desktop.png', 3 ],
           Sawfish => [ 'sawfish_desktop.png', 3 ],
           Waimea => [ 'waimea_desktop.png', 3 ],
           failsafe => [ 'failsafe', 3 ]
	     };
    if (exists($bg->{$wi})) { 
	system("qiv -z $bg_path/$bg->{$wi}[0]"); $nb->set_current_page($bg->{$wi}[1]) 
    }
    exists $bg->{$wi}[2] and $pxm->set_from_pixbuf(gtkcreate_pixbuf($bg->{$wi}[2]));
} 
sub subscribe_mdkclub {
    my $this = shift;
    $this->{product} = Gtk2::RadioButton->new_with_label(undef, N("I have a Product Key and want to register"));
    $this->{member} = Gtk2::RadioButton->new_with_label_from_widget($this->{product}, N("I am already a member"));
    $this->{nothanks} = Gtk2::RadioButton->new_with_label_from_widget($this->{product}, N("No thanks"));
    my $nb_club = Gtk2::Notebook->new; $nb_club->set_show_tabs(0); $nb_club->set_show_border(0);
    gtkappend_page($this->{nb},
		   gtkpack_(Gtk2::VBox->new(0, 3),
			    0, set_darea(N("Mandrakeclub Account"), 'club'),
			    1, create_scrolled_window(
						      #Gtk2::WrappedLabel->new(formatAlaTeX(
						      gtktext_insert(Gtk2::TextView->new,
									 N("Become a Mandrakeclub's member!

Find out all benefits and services that Mandrakeclub provides to you, such as:

   - Full access to commercial applications
   - Special download mirror list exclusively for Mandrakeclub Members
   - Voting for software to put in Mandrakelinux
   - Special discounts for products and services at Mandrakestore
   - plus much more... !!!

If you provide root password, this wizard will add a club urpmi source for commercial applications.")
								     #),
								     ),
						     [ 'never', 'automatic' ],
						     ),
			    0, gtkadd(Gtk2::Frame->new(N("Registration Type")),
				      gtkpack_(Gtk2::VBox->new(0,0),
					       map { my $t = $_->[0]; my $s = $_->[1];
						     0, gtksignal_connect($this->{$t}, clicked => sub { $nb_club->set_current_page($s) })
						 } (["product", 0], ["member", 1], ["nothanks", 2])
					      )
				     )
			   )
		  );
    gtkappend_page($this->{nb},
		   gtkpack_(Gtk2::VBox->new(0,3),
			    0, set_darea(N("Mandrakeclub Account"), 'club'),
			    1, $nb_club
			   )
		  );
    gtkappend_page($nb_club,
		   gtkpack_(Gtk2::VBox->new(0, 2),
			    0, gtkadd(gtkset_shadow_type($this->{gfp} = Gtk2::Frame->new(N("Product Registration")), 'etched_in'),
				      gtkpack_(Gtk2::VBox->new,
					       1, gtkset_border_width(create_packtable({ col_spacings => 10, row_spacings => 10 },
					       	        [ Gtk2::Label->new(N("Registration number:")),
					       gtkpack(Gtk2::HBox->new(0, 0),
							   $this->display_entry),
							  ],
								   [ N("Complete Name:"), $this->{name} = entry_sized() ],
								   [ N("Mail Contact:"), $this->{mailcontact} = entry_sized() ],
								   [ N("Login:"), $this->{newlogin} =  entry_sized() ],
								   [ N("Password:"), $this->{newpasswd} = entry_hidepass() ],
								   [ N("Confirm Password:"), $this->{confirm} = entry_hidepass() ],
								   [ N("Root Password:"), $this->{newroot} = entry_hidepass() ],
								  ),
								      8),
					      )
				     ))
		  );
    gtkappend_page($nb_club,
		   gtkpack_(Gtk2::VBox->new(0, 2),
			    0, gtkadd(gtkset_shadow_type($this->{gfp} = Gtk2::Frame->new(N("Mandrakeclub Registration Update")), 'etched_in'),
				      gtkpack_(Gtk2::VBox->new(0, 5),
					       1, gtkset_border_width(create_packtable({ col_spacings => 10, row_spacings => 10 },
								   [], [],
								   [ N("Login:"), $this->{login} = Gtk2::Entry->new ],
								   [ N("Password:"), $this->{passwd} = entry_hidepass() ],
								   [ N("Root Password:"), $this->{root} = entry_hidepass() ],
								  ),
								  	8),
					      ))
			   )
		  );
    gtkappend_page($nb_club,
		   gtkpack(Gtk2::Label->new(N("You can reuse this part of the wizard to register later by clicking\non Mandrakeonline Services on the desktop or by connecting to \nhttp://www.mandrakeclub.com.\n\nClick on Forward to Finish\n")),
	   )
   );
}
sub privacy_dialog {
    my $this = shift;
    create_dialog(N("Privacy Text"), privacy_text(), { use_markup => 1, transient => $this->{mw}{window}, height => 480, width => 580, scroll => 1 })
}
sub question {
    my $this = shift;
    my %q; my $mode = 1; my $vb; $this->{clicked} = 0;
    foreach my $n (['a', 'ax', 'a1', N("Yes"), 'a2', N("No")], ['b', 'bx', 'b1', N("Ftp mirror"), 'b2', N("Cheap Cd (Internet)"), 'b3', N("Cd Magazine")], ['c', 'cx', 'c1', N("At Home") . N("(Skip next question)"), 'c2', N("In a business"), 'c3', N("Both")], ['d', 'dx', 'd1', N("Small ( < 50)"), 'd2', N("Medium (50 to 500)"), 'd3', N("Large (> 500)")], ['e', 'ex', 'e1', N("Server"), 'e2', N("Desktop"), 'e3', N("Laptop"), 'e4', N("Servers and workstations")], ['f', 'fx', 'f1', N("One box"), 'f2', N("Less than 5"), 'f3', N("More than 5")], ['g', 'gx', 'g1', N("low bandwidth (56k modem)"), 'g2', N("high bandwith (ADSL, Cable ...)")], ['h', 'hx', 'h1', N("Yes"), 'h2', N("No")]) {
	$q{$n->[1]} = Gtk2::RadioButton->new_with_label(undef, '');
	$q{$n->[2]} = Gtk2::RadioButton->new_with_label_from_widget($q{$n->[1]}, $n->[3]);
	$q{$n->[4]} = Gtk2::RadioButton->new_with_label_from_widget($q{$n->[1]}, $n->[5]);
	$q{$n->[6]} = Gtk2::RadioButton->new_with_label_from_widget($q{$n->[1]}, $n->[7]) if $n->[6];
	$q{$n->[8]} = Gtk2::RadioButton->new_with_label_from_widget($q{$n->[1]}, $n->[9]) if $n->[8];
	$this->{$n->[0]} = $n->[1]; 
    } 
    foreach my $m (['dwnemail', N("Email")], ['dwncountry', N("Country"), '1']) { 
	gtkpack_($q{$m->[0]} = Gtk2::HBox->new(0,3),
		 0, Gtk2::Label->new($m->[1]),
		 1, $this->{$m->[0]} = $m->[2] ? Gtk2::Combo->new : entry_sized()
		);
    }
    gtkappend_page($this->{nb},
		   gtkpack_(Gtk2::VBox->new(0, 3),
			    0, set_darea(N("Users Survey"), 'question'),
			    1, gtkpack_(Gtk2::VBox->new(0, 5),
					0, gtksignal_connect(gtkset_active($this->{donotsend} = Gtk2::CheckButton->new(N("Do not send this questionnaire")), !$mode),							     clicked => sub { $mode = !$mode; $vb->set_sensitive($mode) }),
					1, gtkpack_($vb = Gtk2::VBox->new(0,0),
						    1, create_scrolled_window(create_packtable({ homogeneous => 0, col_spacings => 3, row_spacings => 0 },
									map {
									    my $o = $_->[0];
									    if ($o =~ /dwn/) { 
										[ ' ', ' ' ],
										[ $q{$_->[0]}, " " ],
									    } else {
									    [ $_->[0], " " ], 
									    $_->[1] && [ " ", $q{$_->[1]} ], 
									    $_->[2] && [ " ", $q{$_->[2]} ],
									    $_->[3] && [ " ", $q{$_->[3]} ],
									    $_->[4] && [ " ", $q{$_->[4]} ],
                                                                            }
									} ( 
									  [ N("Is this your first Linux system ?"), 'a1', 'a2' ],
									  [ N("Where did you get this distribution ?"), 'b1', 'b2', 'b3' ],
									  [ N("Where are you using this distribution ?"), 'c1', 'c2', 'c3' ],
									  [ N("What is the size of your organisation ?"), 'd1', 'd2', 'd3' ],
									  [ N("For what usage do you plan to use this distribution ?"), 'e1', 'e2', 'e3', 'e4' ],
									  [ N("On how many computers do you plan to install it ?"), 'f1', 'f2', 'f3' ],
									  [ N("Your type of internet connection is"), 'g1', 'g2' ],
									  [ N("I wish to be informed about Mandrakelinux News"), 'h1', 'h2' ],
									  [ 'dwnemail' ],
									  [ 'dwncountry' ]
									  )
											     ))
						   ))));
    foreach my $l (['a', 'a1'], ['a', 'a2'], ['b', 'b1'], ['b', 'b2'], ['b', 'b3'], ['c', 'c1'], ['c', 'c2'], ['c', 'c3'], ['d', 'd1'], ['d', 'd2'], ['d', 'd3'], ['e', 'e1'], ['e', 'e2'], ['e', 'e3'], ['e', 'e4'], ['f', 'f1'], ['f', 'f2'], ['f', 'f3'], ['g', 'g1'], ['g', 'g2'], ['h', 'h1'], ['h', 'h2']) {
	$q{$l->[1]}->signal_connect(clicked => sub { $this->{$l->[0]} = $l->[1]; $this->{clicked} = 1 });
    }
    $this->{dwncountry}->set_popdown_strings(sort(getAllCountries())); $this->{dwncountry}->set_use_arrows_always(1);;
    
}
sub grayed {
    my $this = shift;
    my $c = $this->{mailclient}->entry->get_text ? 1 : 0;
    foreach (qw(vbox server frame)) {
	$this->{$_}->set_sensitive($c);
    }
}
sub get_wm_array {
    my @wm = split(' ', `/usr/sbin/chksession -l`);
    # this is for testing on touba (prod box)
    #    unshift(@wm,'KDE');unshift(@wm,'GNOME'); unshift(@wm, 'WindowMaker');
    #    my $i = 0;
    #   foreach (@wm) { $_ eq "default" and delete $wm[$i]; $i++; last };
    return @wm;
}

sub startwm {
    my $this = shift;
    my $wm = $this->{wmdesktop}->entry->get_text; my $w;
    my $run_wm = {
		  nochoice => sub { 
		      my $auto = any::get_autologin();
		      $w = if_($auto->{autologin}, $auto->{desktop}) || chomp_(find { defined $_ } (cat_("$ENV{HOME}/.wmrc"), $ENV{GDMSESSION})) || 'KDE';   
		      exec_wm($w);
		  },
		  wmchoosen => sub {
		      write_config($wm);
		      exec_wm($wm);
		  }
		 };
    -d "$ENV{HOME}/Documents" or mkdir_p("$ENV{HOME}/Documents");
    if ($wm eq N("Choose Desktop")) { $run_wm->{nochoice}->() } else { $run_wm->{wmchoosen}->() }
}
sub exec_wm {
    my $w = shift;
    Gtk2->main_quit;
    exec("/etc/X11/Xsession", $w);
}
sub write_config {
    my $wm = shift;
    system("xsetroot -solid " . '"#21449C"');
    my $wm_number = sessions_with_order()->{$wm} || '';
    update_gnomekderc("$ENV{HOME}/.dmrc", 'Desktop', Session => "$wm_number$wm");
}
#copied from any.pm
sub sessions_with_order {
    my %h = map { /(.*)=(.*)/ } split(' ', `/usr/sbin/chksession -L`);
    \%h;
}
sub survey {
    my $this = shift;
    my ($resp, $send, $arch, $mail, $lang, $locale);
    my %add;
    #We'll dont exec code when user didn't click on any RadioButton 
#    $this->{clicked} or return;
    my $netconf = '/etc/sysconfig/network-scripts/ifup.d/survey.pl';
# Test Link
#    my $link = 'http://www.mandrakeonline.net/online_survey.php';
# Final Link
    my $link = 'http://poll.mandrakesoft.com/online_survey.php';
    my ($r) = cat_('/etc/mandrake-release') =~ /release\s(\S+)/;
    $arch = chomp_(`/bin/arch`);
    $locale = lang::read('', $>);
    $lang = $locale->{lang};
    foreach my $m (qw(dwnemail dwncountry)) { $this->{$m} and $add{$m} = $m eq 'dwnemail' ? $this->{$m}->get_text : $this->{$m}->entry->get_text };
    map { $resp .= $this->{$_} } qw(a b c d e f g h); 
# Options
#   online_survey.php?rep=a1b2c1d1e3f4&ver=9.2&arch=i586&lang=fr&email=toto.durand@mail.com
    my $ct = getCountry($add{dwncountry});
    $mail = $add{dwnemail};
    if($this->{is_network} && !$this->{sent}) {
	$send = requestURL($link . '?rep=' . $resp . '&ver=' . $r . '&arch=' . $arch . '&lang=' . $lang . '&email='. $mail . '&country_id=' . $ct);
	$this->{sent} = 1;
    } elsif( $< == 0) { 
	output "$netconf", qq(#Automatically generated by drakfw
use strict;
use LWP::UserAgent;
use Net::HTTP;
use HTTP::Message;
use HTTP::Request;

my \$ua = LWP::UserAgent->new;
\$ua->agent("MdkClubAgent/$r" . \$ua->agent);
\$ua->env_proxy;
my \$request = HTTP::Request->new( GET => '$link.'?rep='. $resp .'&ver='. $r .'&arch='. $arch . '&lang=' . $lang . '&email='. $add{dwnmail} . '&country_id=' . $ct');
my \$response = \$ua->request(\$request);
unlink $netconf;
);
	chmod 755, $netconf;
    }
}
sub set_themes {
    my $this = shift;
    my ($wm, $c);
    my $action_themes = {
			 KDE => sub { my %themes_kde = (
                            ("Galaxy 2")  => [ "galaxy", "kwin3_mandrake2"],
                            ("Galaxy Classic")  => [ "galaxy", "kwin3_mandrake" ],
                            ("Galaxy Squared")   => [ "galaxy", "kwin3_mandrake3" ],
                            ("Plastik")  =>  [ "plastik", "kwin3_plastik" ]
						       );
				      $c = $this->{kradio};
				      mkdir_p($this->{kdeconfdir});
				      WriteDefaultTheme();
				      update_gnomekderc($this->{kdeconfdir}.'/kdeglobals', General => (
							 widgetStyle => $themes_kde{$c}[0],
					 	       ));
				      update_gnomekderc($this->{kdeconfdir}.'/kwinrc', Style => (
						         ButtonsOnLeft => 'MS',
                 					 ButtonsOnRight => 'HIAX',
							 CustomButtonPositions => 'false',
							 PluginLib => $themes_kde{$c}[1],
							 ShowToolTips => 'true'					     
						       ));
				  },
			 GNOME => sub { my %themes_gnome =(
                               ("Galaxy 2") => [ "Galaxy2", "Galaxy", "gnome" ],
                               ("Galaxy Classic") => [ "GalaxyClassic", "Galaxy", "gnome" ],
                               ("Galaxy Squared") => [ "GalaxySquared", "Galaxy", "gnome" ],
                               ("Smokey Blue") => [ "Smokey", "Smokey-Blue", "Smokey-Blue" ],
							  );
					$c = $this->{gradio};
					system("gconftool-2 --type=string --set /apps/metacity/general/theme $themes_gnome{$c}[0] &");
					system("gconftool-2 --type=string --set /desktop/gnome/interface/gtk_theme $themes_gnome{$c}[1] &");
					system("gconftool-2 --type=string --set /desktop/gnome/interface/icon_theme $themes_gnome{$c}[2] &");
				    },
			 OTHER => sub { WriteDefaultTheme() }
 			};
    $wm = $this->{wmdesktop}->entry->get_text;
    if (member($wm,('KDE','GNOME'))) { eval { $action_themes->{$wm}->() } } else { $action_themes->{OTHER}->() };
    $this->{nb}->next_page;
}
sub WriteDefaultTheme {
    output "$ENV{HOME}/.gtkrc", qq (# -- THEME AUTO-WRITTEN DO NOT EDIT 
include "/usr/share/themes/Galaxy/gtk/gtkrc"

# -- THEME AUTO-WRITTEN DO NOT EDIT
);
    output "$ENV{HOME}/.gtkrc-2.0", qq (# -- THEME AUTO-WRITTEN DO NOT EDIT
include "/usr/share/themes/Galaxy/gtk-2.0/gtkrc"

# -- THEME AUTO-WRITTEN DO NOT EDIT 
);
  
}
sub mdkclub_checkuser {
    my $this = shift;
    $this->{productkey} = '';
    map { $this->{productkey} .= $this->{$_}->get_text } qw (ent1 ent2 ent3 ent4 ent5); 
    my $login = $this->{newlogin}->get_text || $this->{login}->get_text;
    my $link = 'http://www.mandrakeclub.com/add_user.php';
    my $subsclub = {
		    0 => sub { if ($this->{newroot}->get_text) { my $w = wait_msg($this->{mw}{window}, N("Please wait, contacting Mandrakeclub to initialize updates packages.")); $this->AddUrpmiSource(1); remove_wait_msg($w) }; $this->display_last_page },
		    1 => sub { raiseError($this->{mw}{window}, N("Product code"), N("Wrong Product Code \"%s\". Please provide a Correct Registration number or Skip the wizard \n", $this->{productkey})) },
		    2 => sub { raiseError($this->{mw}{window}, N("login in use"), N("Nickname * %s * already in use or invalid\nPlease choose another one\n", $login)) },
		    3 => sub { raiseError($this->{mw}{window}, N("Email in use"), N("Email already in use or invalid\nCould you provide another one\n")) },
		    4 => sub { raiseError($this->{mw}{window}, N("Invalid Password"), N("Password is invalid\n Please Change it")) },
		    5 => sub { raiseError($this->{mw}{window}, N("Database Error"), N("Database error at server side\n Please connect later with drakclub or drakonline wizard")) },
		    6 => sub { if ($this->{root}->get_text) { my $w = wait_msg(N("Please wait, contacting Mandrakeclub to initialize updates packages.")); $this->AddUrpmiSource(0); remove_wait_msg($w) }; $this->display_last_page },
		    7 => sub { raiseError($this->{mw}{window}, N("No account"), N("You should register to club first. Click back \nand select first choice"))}
		   };
    my $callback_club = {
	  
			 product => sub { 
			     if ($this->{newpasswd}->get_text ne $this->{confirm}->get_text) { 
				 raiseError($this->{mw}{window}, N("Mismatch"), N("The passwords do not match\n Please try again\n"))
			     } elsif (check_valid_email($this->{mailcontact}) != 1) { 
				 raiseError($this->{mw}{window}, N("Invalid Mail"), N("Not a valid mail address!\n")) 
			     } else {
				 $this->{response} = requestURL($link.'?Pcode=' . $this->{productkey}.'&CUSTnick=' . $this->{newlogin}->get_text . '&CUSTemail=' . $this->{mailcontact}->get_text . '&CUSTpass='.$this->{newpasswd}->get_text);
				 if ($this->{response}->is_success) {
				     my $content = $this->{response}->content;
				     if ($content =~ m/(\d+)/) { my $code = sprintf("%d",$1); eval { $subsclub->{$code}->() } }
				 } else { raiseError($this->{mw}{window}, N("Server problem"), N("Problem connecting to server \n")) }
			     }
			 },
			 member => sub { 
			     if (!$this->{login}->get_text) { raiseError($this->{mw}{window}, N("No login"), N("Login must be provided")) } else {
				 $this->{response} = requestURL($link.'?CUSTnick='.$this->{login}->get_text . '&CUSTpass=' . $this->{passwd}->get_text);
				 if ($this->{response}->is_success) {
				     my $content = $this->{response}->content;
				     if ($content =~ m/(\d+)/) { my $code = sprintf("%d",$1); $subsclub->{$code}->() }  
				 } else { raiseError($this->{mw}{window}, N("Server problem"), N("Problem connecting to server \n")) }
			     }
			 },
			 nothanks => sub { $this->display_last_page },
			}; 
    map {
	$this->{$_}->get_active and $callback_club->{$_}->();
    } keys %{ $callback_club };
}
sub AddUrpmiSource {
    my $this = shift;
    my $p = shift; #notebook page 
    my ($login, $password, $rootpassword, $commsu, $ret, $oldmode, $stdin);
    if ($p) { 
	$login = $this->{newlogin}->get_text; $password = $this->{newpasswd}->get_text; $rootpassword = $this->{newroot}->get_text 
    } else { $login = $this->{login}->get_text; $password = $this->{passwd}->get_text; $rootpassword = $this->{root}->get_text };
    my ($r) = cat_('/etc/mandrake-release') =~ /release\s(\S+)/;
    my $stringified = "/usr/sbin/urpmi.addmedia --wget club." . $_ . "_i586_" . $r . " http://" . $login . ":" . $password ."\@www.mandrakeclub.com/downloads2/" . "comm" . "/" . $r . " " . "with ./hdlist.cz";
    my $timeout = 50;
    #    print "ADDING CLUB MEDIUM  \n $stringified \n";
    `stty sane`;
    $commsu = new Expect;
#    $commsu->raw_pty(1);
    $commsu->stty(qw(raw -echo));
    $commsu->spawn("/bin/su -m --command=\"$stringified\" root");
    sleep(2);
    $commsu->log_stdout(0);
    $commsu->expect($timeout,
                    [ qr/Password: $/, sub {
			  $commsu->send("$rootpassword\n");
			  Expect::exp_continue;
			  #$commsu->interact;
		      } ],
		    [ qr/su: /, sub { raiseError($this->{mw}{window}, N("Root Password"), N("Root Password is incorrect")) } ],
		    #[ qr/member/, sub { my $fh = shift; $fh->interact() } ],
		    #[ qr/product/, sub { my $fh = shift; $fh->interact() } ],
		    [ timeout => sub { raiseError($this->{mw}{window}, N("Not responding"), N("Cannot contact Club Site.\nAborting ...")) } ],
                   );
    $commsu->soft_close;
}
sub wait_msg {
    my ($msg, %options) = @_;
    my $mainw = ugtk2->new('club', grab => 1, if_(exists $options{transient}, transient => $options{transient}));
    $mainw->{rwindow}->set_position($options{transient} ? 'center_on_parent' : 'center_always') if !$::isEmbedded;
    my $label = ref($msg) =~ /^Gtk/ ? $msg : Gtk2::Label->new($msg);
    gtkadd($mainw->{window}, gtkpack__(gtkadd(Gtk2::VBox->new(0, 5), $label, if_(exists $options{widgets}, @{$options{widgets}}))));
    $label->signal_connect(expose_event => sub { $mainw->{displayed} = 1; 0 });
    $mainw->sync until $mainw->{displayed};
    gtkset_mousecursor_wait($mainw->{rwindow}->window);
    $mainw->flush;
    $mainw;
}
sub remove_wait_msg { $_[0]->destroy }
sub get2final {
    my $this = shift;
    $this->{Button_Prev}->hide; $this->{Button_SkipWiz}->hide;
    $this->{Button_Next}->set_label(N("Finish"));
}
sub display_last_page {
    my $this = shift;
    $this->get2final;
    $this->{nb}->next_page;
}
sub on_next_clicked {
    my ($this, $stage) = @_;
    $this->{Button_Prev}->set_sensitive(1);
    my $page = $this->{nb}->get_current_page;
    $page == 5 and $this->get2final;
    !$this->{is_download} && $page == 5 and $this->get2final; 
    if (exists($stage->{$page})) { $stage->{$page}->() } else { $this->{nb}->next_page };
}   
sub on_prev_clicked {
    my ($this, $stage) = @_;
    my $page = $this->{nb}->get_current_page;
    $this->{Button_Next}->get_label eq N("Finish") and $this->{Button_Next}->set_label(N("  Next  > "));
    $this->{nb}->prev_page;
    if ($this->{is_download} && $page == 1) { $this->setFirstPage(1) }
}
sub setFirstPage {
    my ($this, $state) = @_;
    if (!$state) {
	$this->{Button_Prev}->set_sensitive(1);
	$this->{Button_Priv}->hide ;	
    } else {
	$this->{Button_Prev}->set_sensitive(0);
	$this->{is_download} and $this->{Button_Priv}->show
    }
}

1;
